remote-hg: don't decode UTF-8 paths into Unicode objects
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
06b1abb5 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
5c08dbbd 25command=
ecda0723 26branch=
d27b876b 27force=
d92a3959 28reference=
70c7ac22 29cached=
48bb3033
GP
30recursive=
31init=
1c244f6e 32files=
06b1abb5 33remote=
31ca3ac3 34nofetch=
32948425 35update=
15fc56a8 36prefix=
73b0898d 37custom_name=
275cd184 38depth=
70c7ac22 39
967b2c66
JS
40# The function takes at most 2 arguments. The first argument is the
41# URL that navigates to the submodule origin repo. When relative, this URL
42# is relative to the superproject origin URL repo. The second up_path
43# argument, if specified, is the relative path that navigates
44# from the submodule working tree to the superproject working tree.
45#
46# The output of the function is the origin URL of the submodule.
47#
48# The output will either be an absolute URL or filesystem path (if the
49# superproject origin URL is an absolute URL or filesystem path,
50# respectively) or a relative file system path (if the superproject
51# origin URL is a relative file system path).
52#
53# When the output is a relative file system path, the path is either
54# relative to the submodule working tree, if up_path is specified, or to
55# the superproject working tree otherwise.
f31a522a
ML
56resolve_relative_url ()
57{
98fcf840 58 remote=$(get_default_remote)
8e7e6f39 59 remoteurl=$(git config "remote.$remote.url") ||
4d689320 60 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 61 url="$1"
99b120af 62 remoteurl=${remoteurl%/}
ea640cc6 63 sep=/
967b2c66
JS
64 up_path="$2"
65
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
69 ;;
758615e2
JS
70 ./*|../*)
71 is_relative=t
72 ;;
967b2c66
JS
73 *)
74 is_relative=t
758615e2 75 remoteurl="./$remoteurl"
967b2c66
JS
76 ;;
77 esac
78
f31a522a
ML
79 while test -n "$url"
80 do
81 case "$url" in
82 ../*)
83 url="${url#../}"
ea640cc6
TR
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
87 ;;
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
91 ;;
92 *)
758615e2
JS
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
98 fi
ea640cc6
TR
99 ;;
100 esac
f31a522a
ML
101 ;;
102 ./*)
103 url="${url#./}"
104 ;;
105 *)
106 break;;
107 esac
108 done
758615e2
JS
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
111}
112
091a6eb0
JK
113# Resolve a path to be relative to another path. This is intended for
114# converting submodule paths when git-submodule is run in a subdirectory
115# and only handles paths where the directory separator is '/'.
116#
117# The output is the first argument as a path relative to the second argument,
118# which defaults to $wt_prefix if it is omitted.
119relative_path ()
120{
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
126
127 while test -n "$curdir"
128 do
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
133 ;;
134 esac
135
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
142 fi
143 done
144
145 echo "$result$target"
146}
147
a7b3269c
DA
148#
149# Get submodule info for registered submodules
150# $@ = path to limit submodule list
151#
152module_list()
153{
091a6eb0 154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
be9d0a3a 155 (
74671241 156 git ls-files -z --error-unmatch --stage -- "$@" ||
be9d0a3a
HV
157 echo "unmatched pathspec exists"
158 ) |
313ee0d6
NMC
159 perl -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
162 my @out = ();
163 my $unmatched = 0;
74671241 164 $/ = "\0";
313ee0d6 165 while (<STDIN>) {
be9d0a3a
HV
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
169 }
313ee0d6
NMC
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
be9d0a3a 176 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
177 }
178 next;
179 }
be9d0a3a
HV
180 push @out, "$_\n";
181 }
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
313ee0d6
NMC
186 }
187 '
a7b3269c
DA
188}
189
be9d0a3a
HV
190die_if_unmatched ()
191{
192 if test "$1" = "#unmatched"
193 then
194 exit 1
195 fi
196}
197
88ce00c3
TK
198#
199# Print a submodule configuration setting
200#
201# $1 = submodule name
202# $2 = option name
203# $3 = default value
204#
205# Checks in the usual git-config places first (for overrides),
206# otherwise it falls back on .gitmodules. This allows you to
207# distribute project-wide defaults in .gitmodules, while still
208# customizing individual repositories if necessary. If the option is
209# not in .gitmodules either, print a default value.
210#
211get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
219 fi
220 printf '%s' "${value:-$default}"
221}
222
223
941987a5
LH
224#
225# Map submodule path to submodule name
226#
227# $1 = path
228#
229module_name()
230{
537601ac 231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 232 sm_path="$1"
fe22e542 233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 236 test -z "$name" &&
64394e3a 237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 238 echo "$name"
941987a5 239}
33aa6fff
LH
240
241#
242# Clone a submodule
243#
23a485e3 244# Prior to calling, cmd_update checks that a possibly existing
ecda0723 245# path is not a git repository.
23a485e3 246# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
247# since it is the location of a new submodule.
248#
33aa6fff
LH
249module_clone()
250{
64394e3a 251 sm_path=$1
73b0898d
JL
252 name=$2
253 url=$3
254 reference="$4"
275cd184 255 depth="$5"
7e60407f
JL
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
260 fi
33aa6fff 261
501770e1
FG
262 gitdir=
263 gitdir_base=
69c30517 264 base_name=$(dirname "$name")
33aa6fff 265
501770e1 266 gitdir=$(git rev-parse --git-dir)
69c30517
JL
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
501770e1
FG
269
270 if test -d "$gitdir"
d92a3959 271 then
64394e3a 272 mkdir -p "$sm_path"
501770e1 273 rm -f "$gitdir/index"
d92a3959 274 else
501770e1 275 mkdir -p "$gitdir_base"
be8779f7
DG
276 (
277 clear_local_git_env
275cd184 278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
be8779f7
DG
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
64394e3a 281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 282 fi
ea115a0d 283
6eafa6d0
JL
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
4dce7d9b
JS
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
294 fi
295 while test "${a%%/*}" = "${b%%/*}"
296 do
297 a=${a#*/}
298 b=${b#*/}
299 done
300 # Now chop off the trailing '/'s that were added in the beginning
301 a=${a%/}
302 b=${b%/}
303
c5bc42b9
BW
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 306 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 307
c5bc42b9 308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
310}
311
862ae6cd
RS
312isnumber()
313{
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315}
316
ecda0723
SV
317#
318# Add a new submodule to the working tree, .gitmodules and the index
319#
ec05df35 320# $@ = repo path
ecda0723
SV
321#
322# optional branch is stored in global branch variable
323#
23a485e3 324cmd_add()
ecda0723 325{
5c08dbbd 326 # parse $args after "submodule ... add".
091a6eb0 327 reference_path=
5c08dbbd
JH
328 while test $# -ne 0
329 do
330 case "$1" in
331 -b | --branch)
332 case "$2" in '') usage ;; esac
333 branch=$2
334 shift
335 ;;
d27b876b
JL
336 -f | --force)
337 force=$1
338 ;;
5c08dbbd 339 -q|--quiet)
2e6a30ef 340 GIT_QUIET=1
5c08dbbd 341 ;;
d92a3959
MT
342 --reference)
343 case "$2" in '') usage ;; esac
091a6eb0 344 reference_path=$2
d92a3959
MT
345 shift
346 ;;
347 --reference=*)
091a6eb0 348 reference_path="${1#--reference=}"
d92a3959 349 ;;
73b0898d
JL
350 --name)
351 case "$2" in '') usage ;; esac
352 custom_name=$2
353 shift
354 ;;
275cd184
FG
355 --depth)
356 case "$2" in '') usage ;; esac
357 depth="--depth=$2"
358 shift
359 ;;
360 --depth=*)
361 depth=$1
362 ;;
5c08dbbd
JH
363 --)
364 shift
365 break
366 ;;
367 -*)
368 usage
369 ;;
370 *)
371 break
372 ;;
373 esac
374 shift
375 done
376
091a6eb0
JK
377 if test -n "$reference_path"
378 then
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
381
382 reference="--reference=$reference_path"
383 fi
384
ecda0723 385 repo=$1
64394e3a 386 sm_path=$2
ecda0723 387
64394e3a
RJ
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
1414e578
JL
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
391 fi
392
64394e3a 393 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
394 usage
395 fi
396
091a6eb0
JK
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
398
ec05df35
ML
399 # assure repo is absolute or relative to parent
400 case "$repo" in
401 ./*|../*)
091a6eb0
JK
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
404
ec05df35
ML
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
407 ;;
408 *:*|/*)
409 # absolute url
410 realrepo=$repo
411 ;;
412 *)
497ee872 413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
414 ;;
415 esac
416
db75ada5
MG
417 # normalize path:
418 # multiple //; leading ./; /./; /../; trailing /
64394e3a 419 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
420 sed -e '
421 s|//*|/|g
422 s|^\(\./\)*||
423 s|/\./|/|g
424 :start
425 s|\([^/]*\)/\.\./||
426 tstart
427 s|/*$||
428 ')
64394e3a
RJ
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 431
64394e3a 432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 433 then
6ff875c5 434 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 435\$sm_path
6ff875c5 436Use -f if you really want to add it." >&2
d27b876b
JL
437 exit 1
438 fi
439
73b0898d
JL
440 if test -n "$custom_name"
441 then
442 sm_name="$custom_name"
443 else
444 sm_name="$sm_path"
445 fi
446
d4264ca3 447 # perhaps the path exists and is already a git repo, else clone it
64394e3a 448 if test -e "$sm_path"
d4264ca3 449 then
64394e3a 450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 451 then
64394e3a 452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 453 else
64394e3a 454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 455 fi
c2f93917 456
d4264ca3 457 else
4b7c286e
JL
458 if test -d ".git/modules/$sm_name"
459 then
460 if test -z "$force"
461 then
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468 else
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
470 fi
471 fi
275cd184 472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
ea10b60c 473 (
74ae1419 474 clear_local_git_env
64394e3a 475 cd "$sm_path" &&
ea10b60c
BJ
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
477 case "$branch" in
478 '') git checkout -f -q ;;
502dc5b6 479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 480 esac
64394e3a 481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 482 fi
73b0898d 483 git config submodule."$sm_name".url "$realrepo"
d4264ca3 484
64394e3a
RJ
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 487
73b0898d
JL
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
490 if test -n "$branch"
491 then
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493 fi &&
31991b02 494 git add --force .gitmodules ||
64394e3a 495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
496}
497
19a31f9c
ML
498#
499# Execute an arbitrary command sequence in each checked out
500# submodule
501#
502# $@ = command to execute
503#
504cmd_foreach()
505{
1d5bec8b
JH
506 # parse $args after "submodule ... foreach".
507 while test $# -ne 0
508 do
509 case "$1" in
510 -q|--quiet)
511 GIT_QUIET=1
512 ;;
15fc56a8
JH
513 --recursive)
514 recursive=1
515 ;;
1d5bec8b
JH
516 -*)
517 usage
518 ;;
519 *)
520 break
521 ;;
522 esac
523 shift
524 done
525
f030c96d
ÆAB
526 toplevel=$(pwd)
527
4dca1aa6
BC
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
530 exec 3<&0
531
a7b3269c 532 module_list |
64394e3a 533 while read mode sha1 stage sm_path
19a31f9c 534 do
be9d0a3a 535 die_if_unmatched "$mode"
64394e3a 536 if test -e "$sm_path"/.git
19a31f9c 537 then
091a6eb0
JK
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
64394e3a 540 name=$(module_name "$sm_path")
15fc56a8 541 (
64394e3a 542 prefix="$prefix$sm_path/"
74ae1419 543 clear_local_git_env
64394e3a 544 cd "$sm_path" &&
091a6eb0
JK
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
547 path=$sm_path &&
15fc56a8
JH
548 eval "$@" &&
549 if test -n "$recursive"
550 then
551 cmd_foreach "--recursive" "$@"
552 fi
4dca1aa6 553 ) <&3 3<&- ||
091a6eb0 554 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
555 fi
556 done
557}
558
70c7ac22 559#
211b7f19 560# Register submodules in .git/config
70c7ac22
LH
561#
562# $@ = requested paths (default to all)
563#
23a485e3 564cmd_init()
70c7ac22 565{
5c08dbbd
JH
566 # parse $args after "submodule ... init".
567 while test $# -ne 0
568 do
569 case "$1" in
570 -q|--quiet)
2e6a30ef 571 GIT_QUIET=1
5c08dbbd
JH
572 ;;
573 --)
574 shift
575 break
576 ;;
577 -*)
578 usage
579 ;;
580 *)
581 break
582 ;;
583 esac
584 shift
585 done
586
a7b3269c 587 module_list "$@" |
64394e3a 588 while read mode sha1 stage sm_path
70c7ac22 589 do
be9d0a3a 590 die_if_unmatched "$mode"
64394e3a 591 name=$(module_name "$sm_path") || exit
c1c259e2 592
091a6eb0
JK
593 displaypath=$(relative_path "$sm_path")
594
c1c259e2 595 # Copy url setting when it is not set yet
2cd9de3e
JL
596 if test -z "$(git config "submodule.$name.url")"
597 then
598 url=$(git config -f .gitmodules submodule."$name".url)
599 test -z "$url" &&
091a6eb0 600 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
601
602 # Possibly a url relative to parent
603 case "$url" in
604 ./*|../*)
605 url=$(resolve_relative_url "$url") || exit
606 ;;
607 esac
608 git config submodule."$name".url "$url" ||
091a6eb0 609 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 610
091a6eb0 611 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 612 fi
70c7ac22 613
2cd9de3e 614 # Copy "update" setting when it is not set yet
32948425
JH
615 upd="$(git config -f .gitmodules submodule."$name".update)"
616 test -z "$upd" ||
2cd9de3e 617 test -n "$(git config submodule."$name".update)" ||
32948425 618 git config submodule."$name".update "$upd" ||
091a6eb0 619 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
70c7ac22
LH
620 done
621}
622
cf419828
JL
623#
624# Unregister submodules from .git/config and remove their work tree
625#
626# $@ = requested paths (use '.' to deinit all submodules)
627#
628cmd_deinit()
629{
630 # parse $args after "submodule ... deinit".
631 while test $# -ne 0
632 do
633 case "$1" in
634 -f|--force)
635 force=$1
636 ;;
637 -q|--quiet)
638 GIT_QUIET=1
639 ;;
640 --)
641 shift
642 break
643 ;;
644 -*)
645 usage
646 ;;
647 *)
648 break
649 ;;
650 esac
651 shift
652 done
653
654 if test $# = 0
655 then
656 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
657 fi
658
659 module_list "$@" |
660 while read mode sha1 stage sm_path
661 do
662 die_if_unmatched "$mode"
663 name=$(module_name "$sm_path") || exit
664
091a6eb0
JK
665 displaypath=$(relative_path "$sm_path")
666
cf419828
JL
667 # Remove the submodule work tree (unless the user already did it)
668 if test -d "$sm_path"
669 then
670 # Protect submodules containing a .git directory
671 if test -d "$sm_path/.git"
672 then
091a6eb0 673 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
674 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
675 fi
676
677 if test -z "$force"
678 then
7b294bf4 679 git rm -qn "$sm_path" ||
091a6eb0 680 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 681 fi
7b294bf4 682 rm -rf "$sm_path" &&
091a6eb0
JK
683 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
684 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
685 fi
686
091a6eb0 687 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
688
689 # Remove the .git/config entries (unless the user already did it)
690 if test -n "$(git config --get-regexp submodule."$name\.")"
691 then
692 # Remove the whole section so we have a clean state when
693 # the user later decides to init this submodule again
694 url=$(git config submodule."$name".url)
695 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 696 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
697 fi
698 done
699}
700
70c7ac22 701#
211b7f19 702# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
703#
704# $@ = requested paths (default to all)
705#
23a485e3 706cmd_update()
70c7ac22 707{
5c08dbbd 708 # parse $args after "submodule ... update".
98dbe63d 709 orig_flags=
5c08dbbd
JH
710 while test $# -ne 0
711 do
712 case "$1" in
713 -q|--quiet)
2e6a30ef 714 GIT_QUIET=1
5c08dbbd 715 ;;
be4d2c83 716 -i|--init)
d92a3959 717 init=1
be4d2c83 718 ;;
06b1abb5
TK
719 --remote)
720 remote=1
721 ;;
31ca3ac3 722 -N|--no-fetch)
31ca3ac3
FF
723 nofetch=1
724 ;;
9db31bdf
NMC
725 -f|--force)
726 force=$1
727 ;;
ca2cedba 728 -r|--rebase)
32948425 729 update="rebase"
ca2cedba 730 ;;
d92a3959
MT
731 --reference)
732 case "$2" in '') usage ;; esac
733 reference="--reference=$2"
98dbe63d
KB
734 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
735 shift
d92a3959
MT
736 ;;
737 --reference=*)
738 reference="$1"
d92a3959 739 ;;
42b49178 740 -m|--merge)
42b49178
JH
741 update="merge"
742 ;;
b13fd5c1 743 --recursive)
b13fd5c1
JH
744 recursive=1
745 ;;
efc5fb6a
JH
746 --checkout)
747 update="checkout"
748 ;;
275cd184
FG
749 --depth)
750 case "$2" in '') usage ;; esac
751 depth="--depth=$2"
752 shift
753 ;;
754 --depth=*)
755 depth=$1
756 ;;
5c08dbbd
JH
757 --)
758 shift
759 break
760 ;;
761 -*)
762 usage
763 ;;
764 *)
765 break
766 ;;
767 esac
98dbe63d
KB
768 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
769 shift
5c08dbbd
JH
770 done
771
d92a3959
MT
772 if test -n "$init"
773 then
774 cmd_init "--" "$@" || return
775 fi
776
1b4735d9 777 cloned_modules=
15ffb7cd
FG
778 module_list "$@" | {
779 err=
64394e3a 780 while read mode sha1 stage sm_path
70c7ac22 781 do
be9d0a3a 782 die_if_unmatched "$mode"
313ee0d6
NMC
783 if test "$stage" = U
784 then
75bf5e60 785 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
786 continue
787 fi
64394e3a 788 name=$(module_name "$sm_path") || exit
5be60078 789 url=$(git config submodule."$name".url)
06b1abb5 790 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
791 if ! test -z "$update"
792 then
793 update_module=$update
794 else
795 update_module=$(git config submodule."$name".update)
796 fi
797
091a6eb0
JK
798 displaypath=$(relative_path "$prefix$sm_path")
799
efc5fb6a
JH
800 if test "$update_module" = "none"
801 then
091a6eb0 802 echo "Skipping submodule '$displaypath'"
efc5fb6a
JH
803 continue
804 fi
805
211b7f19 806 if test -z "$url"
70c7ac22
LH
807 then
808 # Only mention uninitialized submodules when its
809 # path have been specified
810 test "$#" != "0" &&
091a6eb0 811 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 812Maybe you want to use 'update --init'?")"
211b7f19
LH
813 continue
814 fi
815
64394e3a 816 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 817 then
275cd184 818 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
1b4735d9 819 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
820 subsha1=
821 else
64394e3a 822 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 823 git rev-parse --verify HEAD) ||
091a6eb0 824 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 825 fi
211b7f19 826
06b1abb5
TK
827 if test -n "$remote"
828 then
829 if test -z "$nofetch"
830 then
831 # Fetch remote before determining tracking $sha1
832 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
833 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
834 fi
835 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
836 sha1=$(clear_local_git_env; cd "$sm_path" &&
837 git rev-parse --verify "${remote_name}/${branch}") ||
838 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
839 fi
840
01d47215 841 if test "$subsha1" != "$sha1" -o -n "$force"
70c7ac22 842 then
9db31bdf
NMC
843 subforce=$force
844 # If we don't already have a -f flag and the submodule has never been checked out
845 if test -z "$subsha1" -a -z "$force"
b9b378a0 846 then
9db31bdf 847 subforce="-f"
b9b378a0 848 fi
31ca3ac3
FF
849
850 if test -z "$nofetch"
851 then
e5f522d6
JL
852 # Run fetch only if $sha1 isn't present or it
853 # is not reachable from a ref.
64394e3a 854 (clear_local_git_env; cd "$sm_path" &&
f5799e05 855 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 856 test -z "$rev") || git-fetch)) ||
091a6eb0 857 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
858 fi
859
1b4735d9
SO
860 # Is this something we just cloned?
861 case ";$cloned_modules;" in
862 *";$name;"*)
863 # then there is no local change to integrate
864 update_module= ;;
865 esac
866
877449c1 867 must_die_on_failure=
32948425
JH
868 case "$update_module" in
869 rebase)
870 command="git rebase"
091a6eb0
JK
871 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
872 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 873 must_die_on_failure=yes
32948425 874 ;;
42b49178
JH
875 merge)
876 command="git merge"
091a6eb0
JK
877 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
878 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 879 must_die_on_failure=yes
42b49178 880 ;;
6cb5728c
CP
881 !*)
882 command="${update_module#!}"
883 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
884 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
885 must_die_on_failure=yes
886 ;;
32948425 887 *)
9db31bdf 888 command="git checkout $subforce -q"
091a6eb0
JK
889 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
890 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
32948425
JH
891 ;;
892 esac
70c7ac22 893
64394e3a 894 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 895 then
ff968f03 896 say "$say_msg"
877449c1
JH
897 elif test -n "$must_die_on_failure"
898 then
ff968f03 899 die_with_status 2 "$die_msg"
15ffb7cd 900 else
ff968f03 901 err="${err};$die_msg"
877449c1 902 continue
15ffb7cd 903 fi
70c7ac22 904 fi
b13fd5c1
JH
905
906 if test -n "$recursive"
907 then
75bf5e60
WE
908 (
909 prefix="$prefix$sm_path/"
910 clear_local_git_env
911 cd "$sm_path" &&
912 eval cmd_update "$orig_flags"
913 )
15ffb7cd
FG
914 res=$?
915 if test $res -gt 0
916 then
091a6eb0 917 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
918 if test $res -eq 1
919 then
ff968f03 920 err="${err};$die_msg"
15ffb7cd
FG
921 continue
922 else
ff968f03 923 die_with_status $res "$die_msg"
15ffb7cd
FG
924 fi
925 fi
b13fd5c1 926 fi
70c7ac22 927 done
15ffb7cd
FG
928
929 if test -n "$err"
930 then
931 OIFS=$IFS
932 IFS=';'
933 for e in $err
934 do
935 if test -n "$e"
936 then
937 echo >&2 "$e"
938 fi
939 done
940 IFS=$OIFS
941 exit 1
942 fi
943 }
70c7ac22
LH
944}
945
bffe71f4
EM
946set_name_rev () {
947 revname=$( (
74ae1419 948 clear_local_git_env
bffe71f4 949 cd "$1" && {
5be60078
JH
950 git describe "$2" 2>/dev/null ||
951 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
952 git describe --contains "$2" 2>/dev/null ||
953 git describe --all --always "$2"
bffe71f4
EM
954 }
955 ) )
956 test -z "$revname" || revname=" ($revname)"
957}
28f9af5d
PY
958#
959# Show commit summary for submodules in index or working tree
960#
961# If '--cached' is given, show summary between index and given commit,
962# or between working tree and given commit
963#
964# $@ = [commit (default 'HEAD'),] requested paths (default all)
965#
966cmd_summary() {
f2dc06a3 967 summary_limit=-1
d0f64dd4 968 for_status=
1c244f6e 969 diff_cmd=diff-index
f2dc06a3 970
28f9af5d
PY
971 # parse $args after "submodule ... summary".
972 while test $# -ne 0
973 do
974 case "$1" in
975 --cached)
976 cached="$1"
977 ;;
1c244f6e
JL
978 --files)
979 files="$1"
980 ;;
d0f64dd4
PY
981 --for-status)
982 for_status="$1"
983 ;;
f2dc06a3 984 -n|--summary-limit)
862ae6cd
RS
985 summary_limit="$2"
986 isnumber "$summary_limit" || usage
f2dc06a3
PY
987 shift
988 ;;
862ae6cd
RS
989 --summary-limit=*)
990 summary_limit="${1#--summary-limit=}"
991 isnumber "$summary_limit" || usage
992 ;;
28f9af5d
PY
993 --)
994 shift
995 break
996 ;;
997 -*)
998 usage
999 ;;
1000 *)
1001 break
1002 ;;
1003 esac
1004 shift
1005 done
bffe71f4 1006
f2dc06a3
PY
1007 test $summary_limit = 0 && return
1008
3deea89c 1009 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
1010 then
1011 head=$rev
caa9c3ca 1012 test $# = 0 || shift
3deea89c
JH
1013 elif test -z "$1" -o "$1" = "HEAD"
1014 then
14e940d7
JH
1015 # before the first commit: compare with an empty tree
1016 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 1017 test -z "$1" || shift
28f9af5d 1018 else
3deea89c 1019 head="HEAD"
28f9af5d
PY
1020 fi
1021
1c244f6e
JL
1022 if [ -n "$files" ]
1023 then
1024 test -n "$cached" &&
465d6a00 1025 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
1026 diff_cmd=diff-files
1027 head=
1028 fi
1029
28f9af5d 1030 cd_to_toplevel
091a6eb0 1031 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 1032 # Get modified modules cared by user
18076502 1033 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 1034 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
1035 while read mod_src mod_dst sha1_src sha1_dst status name
1036 do
1037 # Always show modules deleted or type-changed (blob<->module)
1038 test $status = D -o $status = T && echo "$name" && continue
1039 # Also show added or modified modules which are checked out
1040 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1041 echo "$name"
1042 done
1043 )
1cb639e6 1044
d0f64dd4
PY
1045 test -z "$modules" && return
1046
18076502 1047 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 1048 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
1049 cut -c2- |
1050 while read mod_src mod_dst sha1_src sha1_dst status name
1051 do
1052 if test -z "$cached" &&
1053 test $sha1_dst = 0000000000000000000000000000000000000000
1054 then
1055 case "$mod_dst" in
1056 160000)
1057 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1058 ;;
1059 100644 | 100755 | 120000)
1060 sha1_dst=$(git hash-object $name)
1061 ;;
1062 000000)
1063 ;; # removed
1064 *)
1065 # unexpected type
6ff875c5 1066 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
1067 continue ;;
1068 esac
1069 fi
1070 missing_src=
1071 missing_dst=
1072
1073 test $mod_src = 160000 &&
30353a40 1074 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
1075 missing_src=t
1076
1077 test $mod_dst = 160000 &&
30353a40 1078 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 1079 missing_dst=t
bffe71f4 1080
091a6eb0
JK
1081 display_name=$(relative_path "$name")
1082
1cb639e6
PY
1083 total_commits=
1084 case "$missing_src,$missing_dst" in
1085 t,)
091a6eb0 1086 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1087 ;;
1088 ,t)
091a6eb0 1089 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1090 ;;
1091 t,t)
091a6eb0 1092 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1093 ;;
1094 *)
1095 errmsg=
1096 total_commits=$(
1097 if test $mod_src = 160000 -a $mod_dst = 160000
1098 then
1099 range="$sha1_src...$sha1_dst"
1100 elif test $mod_src = 160000
1101 then
1102 range=$sha1_src
1103 else
1104 range=$sha1_dst
1105 fi
1106 GIT_DIR="$name/.git" \
b0e621ad 1107 git rev-list --first-parent $range -- | wc -l
1cb639e6 1108 )
eed35595 1109 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1110 ;;
1111 esac
1112
1113 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1114 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1115 if test $status = T
1116 then
b3e73449
ÆAB
1117 blob="$(gettext "blob")"
1118 submodule="$(gettext "submodule")"
1cb639e6
PY
1119 if test $mod_dst = 160000
1120 then
091a6eb0 1121 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1122 else
091a6eb0 1123 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1124 fi
1125 else
091a6eb0 1126 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1127 fi
1128 if test -n "$errmsg"
1129 then
1130 # Don't give error msg for modification whose dst is not submodule
1131 # i.e. deleted or changed to blob
1132 test $mod_dst = 160000 && echo "$errmsg"
1133 else
1134 if test $mod_src = 160000 -a $mod_dst = 160000
1135 then
f2dc06a3
PY
1136 limit=
1137 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1138 GIT_DIR="$name/.git" \
f2dc06a3 1139 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1140 --first-parent $sha1_src...$sha1_dst
1141 elif test $mod_dst = 160000
1142 then
1143 GIT_DIR="$name/.git" \
1144 git log --pretty='format: > %s' -1 $sha1_dst
1145 else
1146 GIT_DIR="$name/.git" \
1147 git log --pretty='format: < %s' -1 $sha1_src
1148 fi
1149 echo
1150 fi
1151 echo
d0f64dd4
PY
1152 done |
1153 if test -n "$for_status"; then
f17a5d34 1154 if [ -n "$files" ]; then
eff80a9f 1155 gettextln "Submodules changed but not updated:" | git stripspace -c
f17a5d34 1156 else
eff80a9f 1157 gettextln "Submodule changes to be committed:" | git stripspace -c
f17a5d34 1158 fi
eff80a9f
JH
1159 printf "\n" | git stripspace -c
1160 git stripspace -c
d0f64dd4
PY
1161 else
1162 cat
1163 fi
28f9af5d 1164}
70c7ac22 1165#
941987a5 1166# List all submodules, prefixed with:
70c7ac22
LH
1167# - submodule not initialized
1168# + different revision checked out
1169#
1170# If --cached was specified the revision in the index will be printed
1171# instead of the currently checked out revision.
1172#
1173# $@ = requested paths (default to all)
1174#
23a485e3 1175cmd_status()
70c7ac22 1176{
5c08dbbd
JH
1177 # parse $args after "submodule ... status".
1178 while test $# -ne 0
1179 do
1180 case "$1" in
1181 -q|--quiet)
2e6a30ef 1182 GIT_QUIET=1
5c08dbbd
JH
1183 ;;
1184 --cached)
1185 cached=1
1186 ;;
64b19ffe
JH
1187 --recursive)
1188 recursive=1
1189 ;;
5c08dbbd
JH
1190 --)
1191 shift
1192 break
1193 ;;
1194 -*)
1195 usage
1196 ;;
1197 *)
1198 break
1199 ;;
1200 esac
1201 shift
1202 done
1203
a7b3269c 1204 module_list "$@" |
64394e3a 1205 while read mode sha1 stage sm_path
70c7ac22 1206 do
be9d0a3a 1207 die_if_unmatched "$mode"
64394e3a 1208 name=$(module_name "$sm_path") || exit
5be60078 1209 url=$(git config submodule."$name".url)
091a6eb0 1210 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1211 if test "$stage" = U
1212 then
1213 say "U$sha1 $displaypath"
1214 continue
1215 fi
64394e3a 1216 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 1217 then
64b19ffe 1218 say "-$sha1 $displaypath"
70c7ac22
LH
1219 continue;
1220 fi
64394e3a 1221 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1222 then
b545cd15 1223 set_name_rev "$sm_path" "$sha1"
64b19ffe 1224 say " $sha1 $displaypath$revname"
70c7ac22
LH
1225 else
1226 if test -z "$cached"
1227 then
64394e3a 1228 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1229 fi
b545cd15 1230 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1231 say "+$sha1 $displaypath$revname"
1232 fi
1233
1234 if test -n "$recursive"
1235 then
1236 (
1237 prefix="$displaypath/"
74ae1419 1238 clear_local_git_env
64394e3a 1239 cd "$sm_path" &&
e15bec0e 1240 eval cmd_status
64b19ffe 1241 ) ||
64394e3a 1242 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1243 fi
1244 done
1245}
2327f61e
DA
1246#
1247# Sync remote urls for submodules
1248# This makes the value for remote.$remote.url match the value
1249# specified in .gitmodules.
1250#
1251cmd_sync()
1252{
1253 while test $# -ne 0
1254 do
1255 case "$1" in
1256 -q|--quiet)
2e6a30ef 1257 GIT_QUIET=1
2327f61e
DA
1258 shift
1259 ;;
82f49f29
PH
1260 --recursive)
1261 recursive=1
1262 shift
1263 ;;
2327f61e
DA
1264 --)
1265 shift
1266 break
1267 ;;
1268 -*)
1269 usage
1270 ;;
1271 *)
1272 break
1273 ;;
1274 esac
1275 done
1276 cd_to_toplevel
1277 module_list "$@" |
64394e3a 1278 while read mode sha1 stage sm_path
2327f61e 1279 do
be9d0a3a 1280 die_if_unmatched "$mode"
64394e3a 1281 name=$(module_name "$sm_path")
2327f61e 1282 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1283
1284 # Possibly a url relative to parent
1285 case "$url" in
1286 ./*|../*)
967b2c66
JS
1287 # rewrite foo/bar as ../.. to find path from
1288 # submodule work tree to superproject work tree
1289 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1290 # guarantee a trailing /
1291 up_path=${up_path%/}/ &&
1292 # path from submodule work tree to submodule origin repo
1293 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1294 # path from superproject work tree to submodule origin repo
1295 super_config_url=$(resolve_relative_url "$url") || exit
1296 ;;
1297 *)
1298 sub_origin_url="$url"
1299 super_config_url="$url"
baede9f8
JH
1300 ;;
1301 esac
1302
ccee6086 1303 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1304 then
091a6eb0
JK
1305 displaypath=$(relative_path "$prefix$sm_path")
1306 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1307 git config submodule."$name".url "$super_config_url"
ccee6086 1308
64394e3a 1309 if test -e "$sm_path"/.git
ccee6086
JH
1310 then
1311 (
1312 clear_local_git_env
64394e3a 1313 cd "$sm_path"
ccee6086 1314 remote=$(get_default_remote)
967b2c66 1315 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1316
1317 if test -n "$recursive"
1318 then
1319 prefix="$prefix$sm_path/"
1320 eval cmd_sync
1321 fi
ccee6086
JH
1322 )
1323 fi
2327f61e
DA
1324 fi
1325 done
1326}
70c7ac22 1327
5c08dbbd
JH
1328# This loop parses the command line arguments to find the
1329# subcommand name to dispatch. Parsing of the subcommand specific
1330# options are primarily done by the subcommand implementations.
1331# Subcommand specific options such as --branch and --cached are
1332# parsed here as well, for backward compatibility.
1333
1334while test $# != 0 && test -z "$command"
70c7ac22
LH
1335do
1336 case "$1" in
cf419828 1337 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1338 command=$1
70c7ac22
LH
1339 ;;
1340 -q|--quiet)
2e6a30ef 1341 GIT_QUIET=1
70c7ac22 1342 ;;
ecda0723
SV
1343 -b|--branch)
1344 case "$2" in
1345 '')
1346 usage
1347 ;;
1348 esac
1349 branch="$2"; shift
1350 ;;
70c7ac22 1351 --cached)
28f9af5d 1352 cached="$1"
70c7ac22
LH
1353 ;;
1354 --)
1355 break
1356 ;;
1357 -*)
1358 usage
1359 ;;
1360 *)
1361 break
1362 ;;
1363 esac
1364 shift
1365done
1366
5c08dbbd 1367# No command word defaults to "status"
af9c9f97
RR
1368if test -z "$command"
1369then
1370 if test $# = 0
1371 then
1372 command=status
1373 else
1374 usage
1375 fi
1376fi
5c08dbbd
JH
1377
1378# "-b branch" is accepted only by "add"
1379if test -n "$branch" && test "$command" != add
1380then
ecda0723 1381 usage
5c08dbbd
JH
1382fi
1383
28f9af5d
PY
1384# "--cached" is accepted only by "status" and "summary"
1385if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1386then
70c7ac22 1387 usage
5c08dbbd
JH
1388fi
1389
1390"cmd_$command" "$@"